import sys
import glob

print ('<?xml version="1.0" encoding="UTF-8"?> <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"> <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:ev="http://www.w3.org/2001/xml-events" version="1.1" baseProfile="full" width="40000cm" height="60000cm">')

Direct_all_gene_file = open(sys.argv[1],'r').readlines()
# 1000,1000 start
# physical position to x,y value

def region_st_ed(all_gene_file) :
	region = []
	for gene in all_gene_file :
		gene = gene.strip().split()
		gene_name = gene[0]
		gene_st = int(gene[1])
		gene_ed = int(gene[2])
		region.append(gene_st)
		region.append(gene_ed)
		region_st = min(region)
		region_ed = max(region)
	return ([region_st,region_ed])


def draw_all_gene(all_gene_file, region_x, region_y) :
	for gene in all_gene_file :
                gene = gene.strip().split()
                gene_name = gene[0]
                gene_st = int(gene[1])
                gene_ed = int(gene[2])
                gene_st_x = 1000 + (gene_st-region_x)/10000
		gene_ed_x = 1000 + (gene_ed-region_x)/10000
                print(' <polygon points= "{0},{1} {2},{1} {2},{3} {0},{3}" style="fill:lightgray;stroke:lightgray;stroke-width:1" />'.format(gene_st_x,region_y,gene_ed_x,region_y+100))

def draw_QTL(QTL_file,region_x,region_y) :
	QTL = open(QTL_file,'r').readlines()
	for qtl in QTL :
		cont = qtl.strip().split('\t')
		QTL_name = cont[0]
		QTL_st = int(cont[2])
		QTL_ed = int(cont[3])
		QTL_st_x = 1000+(QTL_st-region_x)/10000
		QTL_ed_x = 1000+(QTL_ed-region_x)/10000
		print ('        <text x = "{0}" y = "{1}" font-size = "30" > {2} </text>'.format(700,region_y,QTL_name))
		print(' <polygon points= "{0},{1} {2},{1} {2},{3} {0},{3}" style="fill:lightgray;stroke:lightgray;stroke-width:1" />'.format(QTL_st_x,region_y,QTL_ed_x,region_y+50))
		region_y +=100


def draw_link(Link_file, Direct_region_x, Direct_region_y, Self_region_x,Self_region_y, core_synteny) :
	Link = open(Link_file,'r').readlines()
	Core_synteny= open(core_synteny,'r').readlines()
	core = [C.split('\t')[1].split('.')[1] for C in Core_synteny]
	for line in Link :
		cont = line.strip().split()
		x1 = 1000+(int(cont[1])-Direct_region_x)/10000
		x2 = 1000+(int(cont[2])- Direct_region_x)/10000	
		x3 = 1000+(int(cont[4])- Self_region_x)/10000
		x4 = 1000+(int(cont[5])-Self_region_x)/10000
		if cont[0] in core :
			print (' <polygon points= "{0},{1} {2},{3} {4},{5} {6},{7}" style="fill:red;stroke:red;stroke-width:1" />'.format(x1,Direct_region_y-100,x2,Direct_region_y-100,x2,Direct_region_y,x1,Direct_region_y))
			print (' <polygon points= "{0},{1} {2},{3} {4},{5} {6},{7}" style="fill:red;stroke:red;stroke-width:1" />'.format(x1,Direct_region_y,x2,Direct_region_y,x4,Self_region_y,x3,Self_region_y))
			continue
		print (' <polygon points= "{0},{1} {2},{3} {4},{5} {6},{7}" style="fill:gray;stroke:gray;stroke-width:1" />'.format(x1,Direct_region_y,x2,Direct_region_y,x4,Self_region_y,x3,Self_region_y))


#Draw_Vr_LD
Vr_all_gene_file = open('1-1_Vradi_LD_region_all_gene.txt','r').readlines()
Vr_region = region_st_ed(Vr_all_gene_file)
Vr_region_st_x = 1000
Vr_region_ed_x = 1000+ (Vr_region[1]-Vr_region[0])/10000
Vr_region_st_y = 100
print(' <polygon points= "{0},{1} {2},{1} {2},{3} {0},{3}" style="fill:green;stroke:green;stroke-width:1" />'.format(Vr_region_st_x, Vr_region_st_y, Vr_region_ed_x, Vr_region_st_y+100))

#Draw all gene in Vr LD
draw_all_gene(Vr_all_gene_file, Vr_region[0], Vr_region_st_y)

#Draw Vr to Direct Synteny link
#draw_link(Vr_all_gene_file+'_link', Direct_region[0], Direct_region_st_y+100, self_region[0],self_region_st_y,'2-1_synteny_224.txt')
#draw_link('2-1_synteny_224.txt_link', Vr_region[0], Vr_region_st_y+100, Direct_region[0],Direct_region_st_y,'2-1_synteny_224.txt')

#Draw Direct region block
Direct_region = region_st_ed(Direct_all_gene_file)
Direct_region_st_x = 1000
Direct_region_ed_x = 1000 + (Direct_region[1] - Direct_region[0])/10000
Direct_region_st_y = 1000
print(' <polygon points= "{0},{1} {2},{1} {2},{3} {0},{3}" style="fill:green;stroke:green;stroke-width:1" />'.format(Direct_region_st_x, Direct_region_st_y, Direct_region_ed_x, Direct_region_st_y+100))

#Draw all gene in Direct region block
draw_all_gene(Direct_all_gene_file, Direct_region[0], Direct_region_st_y)

#Draw QTL in Direct region
draw_QTL('3-2_Gm_Direct_synteny_224_QTL_related.txt', Direct_region[0], Direct_region_st_y+150)

#Draw Self region block
Self_all_gene_files = glob.glob("7-1_224*all_gene.txt")
self_region_st_x = 1000
self_region_st_y = 2000
for Self_all_gene_file in Self_all_gene_files :
	self_all_gene_file = open(Self_all_gene_file,'r').readlines()
	self_region = region_st_ed(self_all_gene_file)
	if self_region :
		self_region_ed_x = self_region_st_x+(self_region[1]-self_region[0])/10000
		print(' <polygon points= "{0},{1} {2},{1} {2},{3} {0},{3}" style="fill:green;stroke:green;stroke-width:1" />'.format(self_region_st_x, self_region_st_y, self_region_ed_x, self_region_st_y+100))

		#Draw all gene in Self region
		draw_all_gene(self_all_gene_file, self_region[0], self_region_st_y)

		#Draw QTL in Self region
		draw_QTL(Self_all_gene_file+'_QTL', self_region[0],self_region_st_y+150)

		#Draw link
		draw_link(Self_all_gene_file+'_link', Direct_region[0], Direct_region_st_y+100, self_region[0],self_region_st_y,'2-1_synteny_224.txt')
	self_region_st_y += 1500

draw_link('2-1_synteny_224.txt_link', Vr_region[0], Vr_region_st_y+100, Direct_region[0],Direct_region_st_y,'2-1_synteny_224.txt')






print ('</svg>')
